#!/usr/bin/python
import apt_pkg
import os
import sys

def main(cache,dic):
    depends_list = set()
    depends_dict = {}
    
    
    #if len(sys.argv) < 3:
        #return []
    for key in dic:
        package_name = key
        package_version = dic[key]
        
        if not package_name in cache:
            continue
        
        
        depends_list.update(get_depends(cache, package_name, package_version, '='))
        #for member in depends_list:
        while True:
            if len(depends_list) == 0:
                break
            member = depends_list.pop()
            if member[0] in depends_dict:
                if member[1] != depends_dict[member[0]][1] and compare_version(member[1], depends_dict[member[0]][1], member[2]):
                    depends_dict[member[0]] = member
                else:
                    continue
            depends_dict[member[0]] = member
            #print member
            depends_list.update(get_depends(cache,member[0],member[1],member[2]))
    return depends_dict
        
    

def get_depends(cache ,package_name ,package_version ,compare):
    depends_list = []
    if not package_name in cache:
        return []
    
    package = cache[package_name]
    
    if not package.has_versions:
        return []
    
    for version in package.version_list:
        if compare_version(version.ver_str, package_version, compare):
            depends_list_str = version.depends_list_str
            if 'Depends' in depends_list_str:
                lists = depends_list_str['Depends']
                for v in lists:
                    depends_list.append(v[0])
            break
    return depends_list

def compare_version(version1, version2, compare):
    if version2 == '' and compare == '':
        return True
    result = apt_pkg.version_compare(version1, version2)
    if compare == '=':
        if result == 0:
            return True
        else:
            return False
    
    if compare == '>=':
        if result >= 0:
            return True
        else:
            return False
    if compare == '>' or compare == '>>':
        if result > 0:
            return True
        else:
            return False
        
    if compare == '<=':
        if result <= 0:
            return True
        else:
            return False
    
    if compare == '<' or compare == '<<':
        if result < 0:
            return True
        else:
            return False
    
    return False


    
def getDepends(cache, package_name, package_version):
    depends_dict = {}
    if not package_name in cache:
        return None
    
    package = cache[package_name]

    if not package.has_versions:
        return None
    
    i = 0
    for version in package.version_list:
        if version.ver_str == package_version:
            depends_list_str = version.depends_list_str
            if 'Depends' in depends_list_str:
                lists = depends_list_str['Depends']
                for v in lists:
                    d = get_newest_package(cache, v[0])
                    if not d:
                        return None
                    else:
                        depends_dict.update(d)
            break
        i += 1
    if i == package.version_list.__len__():
        return None
    return depends_dict
        
def get_newest_package(cache, tup):
    package_name = tup[0]
    package_version = tup[1]
    compare = tup[2]
    if not package_name in cache:
        return None
    package = cache[package_name]
    
    #if not package.has_versions:
        #return None
    if package.has_provides and not package.has_versions:
        ver_str = ''
        i = 0
        for provide in package.provides_list:
            version = provide[2]
            if i == 0:
                package_name = version.parent_pkg.name
                package_version = version.ver_str
                i = 1
            else:
                if version.parent_pkg.name == package_name and apt_pkg.version_compare(version.ver_str, package_version) > 0:
                    package_version = version.ver_str
        return {package_name : package_version}
    
    for version in package.version_list:
        if compare_version(version.ver_str, package_version, compare):
            return {package_name : version.ver_str}
    return None



if __name__ == '__main__':
    apt_pkg.init()
    cache = apt_pkg.Cache()
    
    result = {}
    
    fp = open("localsoft.txt", "r")
    lines = fp.readlines()
    for line in lines:
        flag = get_newest_package(cache, (line.strip(),'',''))
        if flag is None:
            pass
        else:
            key,value = flag.popitem()
            result[key] = value            


    d = main(cache,result)
    for key in d.keys():
        flag = get_newest_package(cache, d[key])
        if flag is None:
            pass
        else:
            key,value = flag.popitem()
            result[key] = value
    print "-----"
    for key in result.keys():
        print key,result[key]
