$(function(){
    document.ondragstart = function() {
        return false;
    };
    $(".top_list li").on('hover',function(){
        $(this).siblings("li").removeClass("selected").end().addClass("selected");
    });
    $(".table_d tr").on('hover', function(){
        $(this).addClass("hover");
    },function(){
        $(this).removeClass("hover");
    });
    $(".tab_n li").click(function(){
        var num = $(this).index();
        $(this).parents(".title_h").siblings(".soft_list").eq(num).siblings(".soft_list").hide().end().show();
        $(this).siblings("li").removeClass("selected").end().addClass("selected");
    });
});

function long2Date(dateTime){
    var date = [];
    if(!!dateTime){
        var d = new Date(dateTime);
        date.push(d.getFullYear());
        date.push("-");
        var m = d.getMonth()+1;
        if(m < 10){
            m = "0"+m;
        }
        date.push(m);
        date.push("-");
        var dd = d.getDate();
        if(dd < 10){
            dd = "0" + dd;
        }
        date.push(dd);
    }
    return date.join("");
}
function spanTime(dateTime){
    var str;
    if(!!dateTime){
        var today = new Date();
        var n = (today - dateTime)/1000/60/60/24;
        if(n >= 3*30){
            str = "三个月前";
        }else if(n >= 2*30){
            str = "两个月前";
        }else if(n >= 2*7){
            str = "两周前";
        }else if(n >= 7){
            str = "一周前";
        }else if(n > 1){
            str = "一天前";
        }else {
            str = "今天";
        }
    }else{
        str = "未知";
    }
    return str;
}

function textCut(ostr,rnum,escape){
	if(!!!ostr){
		return "";
    }else{
        ostr = escapeWhite(ostr);
    }

	var num=0;
	var nstr = "";
	for(var index = 0; index < ostr.length; index ++){
		var splitstr = 	ostr.charAt(index);
		if(/[\u3400-\u9FFF]/.test(splitstr)){
			num += 2;
		}else{
			num += 1;
		}
		if(num > rnum){
			nstr += "...";
			break;
		}
		nstr += splitstr;
	}
	if(!!escape){
		nstr = nstr.replace(/&/g,'&amp;').replace(/>/g,'&gt;').replace(/</g,'&lt;').replace(/"/g,'&#x22;').replace(/'/g,'&#x27;');
	}
	return '<apan title="'+ostr+'">'+nstr+'</span>';
}

function escapeWhite(ostr){
    if(!!ostr)
    {
        ostr = ostr.replace(/&nbsp;/g,' ');
    }
    return ostr;
}
function escapeII(ostr){
	if(!!ostr)
	{
		ostr = ostr.replace(/&/g,'&amp;').replace(/>/g,'&gt;').replace(/</g,'&lt;').replace(/"/g,'&#x22;').replace(/'/g,'&#x27;');
	}
	return ostr;
}

function maxSize(s){
	if(!!!s){
		s = 0;
	}
	$("#table_height").height(document.documentElement.clientHeight-s); 
	$(".left_menu").height(document.documentElement.clientHeight); 
        $(window).resize(function() {
          $("#table_height").height(document.documentElement.clientHeight-s); 
          $(".left_menu").height(document.documentElement.clientHeight); 
        });
}
function getQueryStr(localStrTmp,str) {
    var rs = new RegExp("(^|)" + str + "=([^&]*)(&|$)", "gi").exec(localStrTmp), tmp;
    if (tmp = rs) {
        return tmp[2];
    }
    // parameter cannot be found
    return "";
}

(function($) {
    $.getUrlParam = function(name) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
        var r = window.location.search.substr(1).match(reg);
        if (r !== null)
            return unescape(r[2]);
        return null;
    };

    $.convertFromkb = function(size) {
        var unit = "KB";
        var csize = "0";
        if(null !== size){
            if(size >= 1024*1024*1024){
                csize = (parseInt(size)/(1024*1024*1024)).toFixed(2);
                unit = "GB"
            }else if(size >= 512*1024){
                csize = (parseInt(size)/(1024*1024.0)).toFixed(2);
                unit = "MB"
            }else {
                csize = (parseInt(size)/(1024)).toFixed(2);
            }
        }
        return csize + unit;
    };

    $._escape = function(text){
        text = text.replace(new RegExp("&", "gm"), "&amp;")
            .replace(new RegExp("<", "gm"), "&lt;")
            .replace(new RegExp(">", "gm"), "&gt;")
            .replace(new RegExp("\'", "gm"), "&apos;")
            .replace(new RegExp("\"", "gm"), "&quot;");
        return text;
    };

    $._unescape = function(text){
        text = text.replace(new RegExp("&lt;", "gm"), "<")
            .replace(new RegExp("&gt;", "gm"), ">")
            .replace(new RegExp("&apos;", "gm"), "\'")
            .replace(new RegExp("&quot;", "gm"), "\"")
            .replace(new RegExp("&nbsp;", "gm"), " ")
            .replace(new RegExp("&amp;", "gm"), "&");
        return text;
    };

    $.textCut = function(text, remainNum, escape, symbol) {
        var sb = new Array;
        var _otext = text;
        var showOneline=false;
        if(remainNum > 100){
            remainNum = remainNum - 100;
            showOneline = true;
        }
        if(null === text){
            text = "";
        }
        if(!!!symbol || null === symbol || remainNum < symbol.length){
            symbol = "";
        }
        var subs = text.split("");
        var len = 0;
        var olen = 0;
        for(var index in subs){
            if(subs[index].match("[\u4E00-\u9FA5]")){
                len += 2;
            }else{
                len += 1;
            }
            olen += 1;
            sb.push(subs[index]);
            if(len >= remainNum || olen >= subs.length){
                break;
            }
        }
        text = sb.join("");
        if(olen < subs.length && text.length > symbol.length){
            text = text.substring(0, text.length - symbol.length + 1);
            text += symbol;
        }
        if(escape){
            text = $._escape(text);
            _otext = $._escape(_otext);
        }
        if(showOneline){
            return "<span class='text-oneLine'  title='" + _otext + "'>" + text + "</span>";
        }
        return "<span title='" + _otext + "'>" + text + "</span>";
    };

    $.averageScore = function(score, ratercount){
        var average = 0;
        if(null === score){
            score = 0;
        }
        if(null === ratercount || ratercount === 0){
            average = 0;
        }else{
            if(score >= ratercount * 10){
                average = 10;
            }else {
                average = (score/ratercount).toFixed(1);
            }
        }
        return average;
    };
})(jQuery);
